#include <stdio.h>
#include <unistd.h>
#include <sys/wait.h>

int main()
{
    pid_t pid = fork();
    if (pid == -1) {
        perror("fork()");
        return 1;
    } else if (pid == 0) {
        printf("Hello from child!\n");
        return 0;
    } else {
        int status;

        printf("Hello from parent!\n");

        printf("Waiting for child process %d..\n", pid);

        int result = waitpid(pid, &status, 0);
        if (result == -1) {
            perror("waitpid()");
            return 1;
        }

        printf("Child process %d exited with status %d\n", pid, WEXITSTATUS(status));
    }

    return 0;
}
